# Build configuration

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 0
%endif

%bcond_without examples

# Versioning

%define qtmajor_p 1

%define qtmajor 6
%define qtminor 7
%define qtsubminor 1
%define qtversion  %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 2

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qtmultimedia-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqt6multimedia          %mklibname qt%{qtmajor}multimedia %{qtmajor}
%define libqt6multimedia_d        %mklibname qt%{qtmajor}multimedia -d

%define libqt6multimedia_p        %mklibname qt%{qtmajor}multimedia-plugins

%define libqt6multimediawidgets   %mklibname qt%{qtmajor}multimediawidgets %{qtmajor}
%define libqt6multimediawidgets_d %mklibname qt%{qtmajor}multimediawidgets -d

%define libqtmultimediaquick      %mklibname qt%{qtmajor}multimediaquick %{qtmajor}
%define libqtmultimediaquick_d    %mklibname qt%{qtmajor}multimediaquick -d

%define libqt6spatialaudio        %mklibname qt%{qtmajor}spatialaudio %{qtmajor}
%define libqt6spatialaudio_d      %mklibname qt%{qtmajor}spatialaudio -d

%define libqt6quick3dspatialaudio %mklibname qt%{qtmajor}quick3dspatialaudio %{qtmajor}
%define libquick3dspatialaudio_d  %mklibname qt%{qtmajor}quick3dspatialaudio -d

%define libgstreamermediaplugin_d %mklibname qt%{qtmajor}qgstreamermediaplugin -d

Name:           qtmultimedia6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} Multimedia component
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io/
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
#Branch Patchs

#Trunk Patchs

#Patch from Mageia

BuildRequires:  qtbase6-devel = %version

BuildRequires:  ffmpeg-devel
BuildRequires:  pkgconfig(gstreamer-1.0)
BuildRequires:  pkgconfig(gstreamer-app-1.0)
BuildRequires:  pkgconfig(gstreamer-audio-1.0)
BuildRequires:  pkgconfig(gstreamer-base-1.0)
BuildRequires:  pkgconfig(gstreamer-pbutils-1.0)
BuildRequires:  pkgconfig(gstreamer-video-1.0)
BuildRequires:  pkgconfig(gstreamer-bad-audio-1.0)

BuildRequires:  pkgconfig(libpulse)
BuildRequires:  pkgconfig(libpulse-mainloop-glib)
BuildRequires:  pkgconfig(alsa)
BuildRequires:  pkgconfig(openal)
BuildRequires:  pkgconfig(xrandr)

BuildRequires:  cmake(Qt6Qml) >= %version
BuildRequires:  cmake(Qt6Quick) >= %version
BuildRequires:  cmake(Qt6ShaderTools) >= %version
BuildRequires:  cmake(Qt6Gui) >= %version
BuildRequires:  cmake(Qt6Network) >= %version
BuildRequires:  cmake(Qt6Svg) >= %version
BuildRequires:  cmake(Qt6Widgets) >= %version
BuildRequires:  cmake(Qt6QuickTest) >= %version
BuildRequires:  cmake(Qt6QuickControls2) >= %version
BuildRequires:  cmake(Qt6Quick3D) >= %version
BuildRequires:  qttools6
BuildRequires:  ninja

Requires:       %{libqt6multimedia_p} = %version

Provides:       qt%{qtmajor}-qtmultimedia = %{version}-%{release}

%description
Qt%{qtmajor} Multimedia component.

%files
%_qt6_qmldir/QtMultimedia/
%_qt6_qmldir/QtQuick3D/SpatialAudio/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtMultimedia%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools6-assistant
Recommends:     qttools6-assistant

%description doc
Documentation for APIs and tools in QtMultimedia%{qtmajor} package for use with
Qt Assistant.

%files doc
%{_qt6_docdir}/qtmultimedia.qch
%{_qt6_docdir}/qtmultimedia/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqt6multimedia}
Summary:        Qt%{qtmajor} Multimedia Library
Group:          System/Libraries
Requires:       %{name} >= %{version}

%description -n %{libqt6multimedia}
Qt%{qtmajor} Multimedia Component Library.

%files -n %{libqt6multimedia}
%{_qt6_libdir}/libQt6Multimedia.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqt6multimedia_p}
Summary:        Qt%{qtmajor} Multimedia plugins
Group:          System/Libraries

%description -n %{libqt6multimedia_p}
Qt%{qtmajor} Multimedia plugins.

%files -n %{libqt6multimedia_p}
%dir %{_qt6_plugindir}/multimedia/
%{_qt6_plugindir}/multimedia/libgstreamermediaplugin.so
%{_qt6_plugindir}/multimedia/libffmpegmediaplugin.so

#------------------------------------------------------------------------------

%package -n     %{libqt6multimedia_d}
Summary:        Devel files needed to build apps based on QtMultimedia
Group:          Development/KDE and Qt
Requires:       %{libqt6multimedia} = %version
Requires:       %name >= %version
Provides:       libqtmultimedia6-devel = %version
Provides:       libqt6multimedia-devel = %version
Provides:       qtmultimedia6-devel = %version
Provides:       qt6multimedia-devel = %version

Provides:       libqtmultimedia6-private-devel = %version
Provides:       libqt6multimedia-private-devel = %version
Provides:       qtmultimedia6-private-devel = %version
Provides:       qt6multimedia-private-devel = %version

%description -n %{libqt6multimedia_d}
Devel files needed to build apps based on QtMultimedia.

%files -n %{libqt6multimedia_d}
%{_qt6_includedir}/QtMultimedia/
%{_qt6_libdir}/libQt6Multimedia.so
%{_qt6_libdir}/libQt6BundledResonanceAudio.a
%{_qt6_libdir}/cmake/Qt6Multimedia/
%{_qt6_libdir}/libQt6Multimedia.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_multimedia.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_multimedia_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6multimedia_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/Multimedia.json
%{_qt6_libdir}/pkgconfig/Qt6Multimedia.pc
%if %{with examples}
%{_qt6_examplesdir}/multimedia/
%endif
#
%{_qt6_libdir}/cmake/Qt6/
%{_qt6_libdir}/cmake/Qt6BuildInternals/StandaloneTests/QtMultimediaTestsConfig.cmake

#------------------------------------------------------------------------------

%package -n     %{libqt6multimediawidgets}
Summary:        Qt%{qtmajor} Multimedia Widgets Library
Group:          System/Libraries
Requires:       %name >= %version

%description -n %{libqt6multimediawidgets}
Qt%{qtmajor} Multimedia Widgets Component Library.

%files -n %{libqt6multimediawidgets}
%{_qt6_libdir}/libQt6MultimediaWidgets.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqt6multimediawidgets_d}
Summary:        Devel files needed to build apps based on QtMultimediaWidget
Group:          Development/KDE and Qt
Requires:       %{libqt6multimediawidgets} = %version
Provides:       libqtmultimediawidgets6-devel = %version
Provides:       libqt6multimediawidgets-devel = %version
Provides:       qtmultimediawidgets6-devel = %version
Provides:       qt6multimediawidgets-devel = %version

Provides:       libqtmultimediawidgets6-private-devel = %version
Provides:       libqt6multimediawidgets-private-devel = %version
Provides:       qtmultimediawidgets6-private-devel = %version
Provides:       qt6multimediawidgets-private-devel = %version

%description -n %{libqt6multimediawidgets_d}
Devel files needed to build apps based on QtMultimediaWidget.

%files -n %{libqt6multimediawidgets_d}
%{_qt6_includedir}/QtMultimediaWidgets/
%{_qt6_libdir}/libQt6MultimediaWidgets.so
%{_qt6_libdir}/cmake/Qt6MultimediaWidgets/
%{_qt6_libdir}/libQt6MultimediaWidgets.prl
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_multimediawidgets.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_multimediawidgets_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6multimediawidgets_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/MultimediaWidgets.json
%{_qt6_libdir}/pkgconfig/Qt6MultimediaWidgets.pc

#------------------------------------------------------------------------------

%package -n     %{libqtmultimediaquick}
Summary:        Qt%{qtmajor} Multimedia Quick Library
Group:          System/Libraries
Requires:       %name >= %version

%description -n %{libqtmultimediaquick}
Qt%{qtmajor} Multimedia Quick Component Library.

%files -n %{libqtmultimediaquick}
%{_qt6_libdir}/libQt6MultimediaQuick.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtmultimediaquick_d}
Summary:        Devel files needed to build apps based on QtMultimediaQuick
Group:          Development/KDE and Qt
Requires:       %{libqtmultimediaquick} = %version
Provides:       libqtmultimediaquick6-devel = %version
Provides:       libqt6multimediaquick-devel = %version
Provides:       qt6multimediaquick-devel = %version
Provides:       qtmultimediaquick6-devel = %version

%description -n %{libqtmultimediaquick_d}
Devel files needed to build apps based on QtMultimediaQuick.

%files -n %{libqtmultimediaquick_d}
%{_qt6_includedir}/QtMultimediaQuick/
%{_qt6_libdir}/libQt6MultimediaQuick.so
%{_qt6_libdir}/cmake/Qt6Qml/QmlPlugins/
%{_qt6_libdir}/libQt6MultimediaQuick.prl
%{_qt6_libdir}/cmake/Qt6MultimediaQuickPrivate/
%{_qt6_libdir}/qt6/metatypes/qt6multimediaquickprivate_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/MultimediaQuickPrivate.json
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_multimediaquick_private.pri

#------------------------------------------------------------------------------

%package -n     %{libqt6spatialaudio}
Summary:        Qt%{qtmajor} Spatial Audio Library
Group:          System/Libraries
Requires:       %name >= %version

%description -n %{libqt6spatialaudio}
Qt%{qtmajor} Spatial Audio Component Library.

%files -n %{libqt6spatialaudio}
%{_qt6_libdir}/libQt6SpatialAudio.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqt6spatialaudio_d}
Summary:        Devel files needed to build apps based on QtSpatialAudio
Group:          Development/KDE and Qt
Requires:       %{libqt6spatialaudio} = %version
Provides:       libqtspatialaudio6-devel = %version
Provides:       libqt6spatialaudio-devel = %version
Provides:       qt6spatialaudio-devel = %version
Provides:       qtspatialaudio6-devel = %version

%description -n %{libqt6spatialaudio_d}
Devel files needed to build apps based on QtSpatialAudio.

%files -n %{libqt6spatialaudio_d}
%{_qt6_includedir}/QtSpatialAudio/
%{_qt6_libdir}/libQt6SpatialAudio.so
%{_qt6_libdir}/libQt6SpatialAudio.prl
%{_qt6_libdir}/cmake/Qt6SpatialAudio/
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_spatialaudio.pri
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_spatialaudio_private.pri
%{_qt6_libdir}/qt6/metatypes/qt6spatialaudio_relwithdebinfo_metatypes.json
%{_qt6_libdir}/pkgconfig/Qt6SpatialAudio.pc
%{_qt6_libdir}/qt6/modules/SpatialAudio.json
%if %{with examples}
%{_qt6_examplesdir}/spatialaudio/
%endif
#
%{_qt6_libdir}/cmake/Qt6BundledResonanceAudio/

#------------------------------------------------------------------------------

%package -n     %{libqt6quick3dspatialaudio}
Summary:        Qt%{qtmajor} Quick3D Spatial Audio Library
Group:          System/Libraries
Requires:       %name >= %version

%description -n %{libqt6quick3dspatialaudio}
Qt%{qtmajor} Quick3D Spatial Audio Component Library.

%files -n %{libqt6quick3dspatialaudio}
%{_qt6_libdir}/libQt6Quick3DSpatialAudio.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libquick3dspatialaudio_d}
Summary:        Devel files needed to build apps based on QtQuick3DSpatialAudio
Group:          Development/KDE and Qt
Requires:       %{libqt6quick3dspatialaudio} = %version
Provides:       libqtquick3dspatialaudio6-devel = %version
Provides:       libqt6quick3dspatialaudio-devel = %version
Provides:       qt6quick3dspatialaudio-devel = %version
Provides:       qtquick3dspatialaudio6-devel = %version

%description -n %{libquick3dspatialaudio_d}
Devel files needed to build apps based on QtQuick3DSpatialAudio.

%files -n %{libquick3dspatialaudio_d}
%{_qt6_includedir}/QtQuick3DSpatialAudio/
%{_qt6_libdir}/libQt6Quick3DSpatialAudio.so
%{_qt6_libdir}/cmake/Qt6Quick3DSpatialAudioPrivate/
%{_qt6_libdir}/libQt6Quick3DSpatialAudio.prl
%{_qt6_libdir}/qt6/metatypes/qt6quick3dspatialaudioprivate_relwithdebinfo_metatypes.json
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_quick3dspatialaudio_private.pri
%{_qt6_libdir}/qt6/modules/Quick3DSpatialAudioPrivate.json

#------------------------------------------------------------------------------

%package -n     %{libgstreamermediaplugin_d}
Summary:        Devel files needed to build apps based on QtQGstreamerMediaPlugin
Group:          Development/KDE and Qt
Provides:       libqtqgstreamermediaplugin6-devel = %version
Provides:       libqt6qgstreamermediaplugin-devel = %version
Provides:       qt6qgstreamermediaplugin-devel = %version
Provides:       qtqgstreamermediaplugin6-devel = %version

%description -n %{libgstreamermediaplugin_d}
Devel files needed to build apps based on QtQGstreamerMediaPlugin.

%files -n %{libgstreamermediaplugin_d}
%{_qt6_includedir}/QtQGstreamerMediaPlugin/
%{_qt6_libdir}/cmake/Qt6QGstreamerMediaPluginPrivate/
%{_qt6_libdir}/libQt6QGstreamerMediaPlugin.a
%{_qt6_libdir}/libQt6QGstreamerMediaPlugin.prl
%{_qt6_libdir}/qt6/metatypes/qt6qgstreamermediapluginprivate_relwithdebinfo_metatypes.json
%{_qt6_archdatadir}/mkspecs/modules/qt_lib_qgstreamermediaplugin_private.pri
%{_qt6_libdir}/qt6/modules/QGstreamerMediaPluginPrivate.json

#------------------------------------------------------------------------------

%prep
%autosetup -p1 -n qtmultimedia-everywhere-src-%{qtversion}

%build
%cmake_qt6 %{!?with_examples:-DQT_BUILD_EXAMPLES:BOOL=OFF}
%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete

## .prl/.la file love
# nuke .prl reference(s) to %%buildroot, excessive (.la-like) libs
pushd %{buildroot}%{_qt6_libdir}
for prl_file in libQt6*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd


%changelog
* Tue Jun 11 2024 daviddavid <daviddavid> 6.7.1-2.mga10
+ Revision: 2072544
- rebuild for 'Qt_$MAJOR_PRIVATE_API' settings

* Thu May 23 2024 daviddavid <daviddavid> 6.7.1-1.mga10
+ Revision: 2066783
- New version 6.7.1

* Thu Feb 15 2024 daviddavid <daviddavid> 6.6.2-1.mga10
+ Revision: 2041636
- New version 6.6.2

* Fri Oct 20 2023 daviddavid <daviddavid> 6.6.0-1.mga10
+ Revision: 1999774
- New version 6.6.0

* Sun Sep 10 2023 neoclust <neoclust> 6.5.2-1.mga10
+ Revision: 1985984
- New version 6.5.2

* Tue Dec 27 2022 daviddavid <daviddavid> 6.4.1-2.mga9
+ Revision: 1927115
- enable ffmpeg plugin support
- enable QtQuick3D support
- build examples

* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923047
- New version 6.4.1

* Tue Oct 04 2022 wally <wally> 6.4.0-1.mga9
+ Revision: 1894827
- build using -msse2 on i586
- add Qt SpatialAudio lib and multimedia plugins pkg
+ neoclust <neoclust>
- New version 6.4.0

* Wed Sep 14 2022 wally <wally> 6.3.1-1.mga9
+ Revision: 1888247
- new version 6.3.1 (from neoclust)
- reintroduce qtmultimediaquick lib

* Fri Jul 29 2022 wally <wally> 6.3.0-1.mga9
+ Revision: 1872868
- disable examples as they needs pkg itself to build
- drop qtmultimediaquick lib
+ papoteur <papoteur>
- Mass Rebuild for dependencies
+ neoclust <neoclust>
- New version 6.3.0

* Sun Apr 10 2022 tmb <tmb> 6.2.3-2.mga9
+ Revision: 1848540
- Mageia 9 Mass Rebuild

* Wed Mar 16 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1794362
- New version 6.2.3
+ papoteur <papoteur>
- imported package qtmultimedia6

